---
title: XRSession.cancelAnimationFrame()
slug: Web/API/XRSession/cancelAnimationFrame
tags:
  - API
  - AR
  - Augmented Reality
  - Experimental
  - Method
  - Reference
  - VR
  - Virtual Reality
  - WebXR
  - WebXR Device API
  - XRSession
  - cancelAnimationFrame()
---
<div>{{securecontext_header}}{{APIRef("WebXR")}}</div>

<p><span class="seoSummary">The <strong><code>cancelAnimationFrame()</code></strong> method of the {{domxref("XRSession")}} interface cancels an animation frame which was previously requested by calling {{DOMxRef("XRSession.requestAnimationFrame", "requestAnimationFrame")}}.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>xrSession</em>.cancelAnimationFrame(<em>handle</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>handle</code></dt>
 <dd>The unique value returned by the call to {{DOMxRef("XRSession.requestAnimationFrame", "requestAnimationFrame()")}} that previously scheduled the animation callback.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>This function has no effect if the specified <code>handle</code> cannot be found.</p>

<h2 id="Example">Example</h2>

<p>In the example below we see code which starts up a WebXR session if immersive VR mode is supported. Once started, the session schedules its first frame to be rendered by calling {{DOMxRef("XRSession.requestAnimationFrame", "requestAnimationFrame()")}}.</p>

<p>The <code>pauseXR()</code> function shown at the bottom can be called to suspend the WebVR session, in essence, by canceling any pending animation frame callback. Since each frame callback schedules the next one, removing the callback terminates updating of the WebXR scene.</p>

<pre class="brush: js">const XR = navigator.xr;

let requestHandle = null;
let xrSession = null;

if (XR) {
  XR.isSessionSupported('immersive-vr')
  .then((isSupported) =&gt; {
    if (isSupported) {
      startXR();
    }
  });
}

function frameCallback(time, xrFrame) {
  xrSession.requestAnimationFrame(frameCallback);

  // Update and render the frame
}

async function startXR() {
  xrSession = XR.requestSession("immersive-vr");

  if (xrSession) {
    stopButton.onclick = stopXR;
    requestHandle = xrSession.requestAnimationFrame(frameCallback);
  }
}

function pauseXR() {
  if (xrSession &amp;&amp; requestHandle) {
    xrSession.cancelAnimationFrame(requestHandle);
    requestHandle = null;
  }
}

</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#dom-xrsession-cancelanimationframe","XRSession.cancelAnimationFrame")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRSession.cancelAnimationFrame")}}</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{DOMxRef("Window.cancelAnimationFrame")}}</li>
 <li>{{domxref("XRSession.requestAnimationFrame")}}</li>
</ul>
